#ifndef POINT_H
#define POINT_H

#include <vector>
#include <list>

using namespace std;

namespace CommonTilton
{
  class Point
  {
    public:
    //  CONSTRUCTORS and DESTRUCTOR
      Point();
      Point(const int& x, const int& y);
      Point(const Point& source);
      virtual ~Point();
 
   //  MODIFICATION MEMBER FUNCTIONS
      void operator =(const Point& source);
      void set_col(const int& value)
           { col = value; }
      void set_x(const int& value)
           { col = value; }
      void set_row(const int& value)
           { row = value; }
      void set_y(const int& value)
           { row = value; }

   //  CONSTANT MEMBER FUNCTIONS
      bool operator ==(const Point& source);
      double distance(Point& other_point);
      int get_col() const { return col; }
      int get_x() const { return col; }
      int get_row() const { return row; }
      int get_y() const { return row; }
      void print();

   // FRIEND FUNCTIONS and CLASSES
      friend void print_path(vector<Point>& path);
      friend void add_all(vector<Point>& base_path, vector<Point>& add_path);
      friend void add_all(list<Point>& base_path, vector<Point>& add_path);
      friend void add_all(vector<Point>& base_path, list<Point>& add_path);
      friend bool contains(vector<Point>& base_path, Point& cmp_pt);
      friend int lastIndexOf(vector<Point>& base_path, Point& cmp_pt);

    protected:

    private:
   //  PRIVATE DATA
      int col,row;
  };

} // CommonTilton

#endif /* POINT_H */
