#ifndef SHAPE_H
#define SHAPE_H

#include <string>
#ifdef SHAPEFIL
#include <shapefil.h>
#endif

using namespace std;

namespace CommonTilton
{

  class Shape 
  {
    public:
    // Constructors and Destructor
      Shape();
      virtual ~Shape();

    // Member functions
#ifdef SHAPEFIL
      void open(const string& file_name);
      void read(const string& site_type);
      void close();
#else
      void ascii_read(const string& file_name);
#endif
      bool valid() const { return shape_flag; }
      void print();
      void ascii_write(const string& file_name);
      int get_nb_entities() const { return nb_entities; }
      double get_X(const int& entity) const { return X[entity]; }
      double get_Y(const int& entity) const { return Y[entity]; }

    protected:

    private:
   // Shape data file information
      bool shape_flag;             // True if shape data is valid
      int nb_entities;             // Number of shape entities/structures.
#ifdef SHAPEFIL
      SHPHandle hSHP;		   // Shape File Handle
      int shapeType;               // Shapetype (must be SHPT_POINT)
#endif
      double minBound[4];          // X, Y, Z and M minimum values
      double maxBound[4];          // X, Y, Z and M maximum values
      double *X;                   // X location array
      double *Y;                   // Y location array

   // Xbase data file information
#ifdef SHAPEFIL
      DBFHandle hDBF;              // DBF File Handle
      int nb_records;              // Number of DBF records (must match nb_entities)
      int site_type_field_index;   // Field index for Site Type field
#endif

      bool data_flag;
  };

} // CommonTilton

#endif /* SHAPE_H */
